# -*- coding: utf-8 -*-
"""
Created on Wed Dec 12 16:00:30 2018
@author: Fredrik
"""
import pngtes as p

def whiteLines(d,cubeSize, memberSize, RGBval, spacing, xStart, yStart, xEnd, yEnd,sLayer,spLid, platformType,RGBcorner,layer,frameThickness):
      
    
    i = 0; #pixelcounter
    mbSize=int(memberSize/50)#50uM = 1 pixel, 100 = 2, adapt to printers pixel size
    
    #--------------------Drawing of horizontal features (grids)------------------------------------
            
    if sLayer> 0 or spLid>0: #if a horizontal layer (cubic grid)
        while i <= cubeSize:                                

                if yStart+i <= yEnd: # if next horizontal line is withing y boundary, draw line
                  d.line((xStart, yStart+i, xEnd,yStart+i), width=mbSize, fill=(RGBval,RGBval,RGBval)) #draw horizontal line
                if xStart+i <= xEnd:  #IF next xvertical line within x-boundary
                  d.line((xStart+i, yStart, xStart+i, yEnd), width =mbSize, fill=(RGBval,RGBval,RGBval)) # draw vertical line             
                i+=spacing#*mbSize #jump i pixels between each line  

        cornerCorection(d,RGBval,RGBcorner,xStart, yStart,xEnd,yEnd,spLid,spacing,mbSize,sLayer) #controls light for beam thickness within structure

        i = 0; #reset pixel counter before wiping out with black on post layers
        
    #-------------------------------------Drawing of vertical features------------------------------------------------------#
    elif sLayer < 1:# then only draw vertical beams
        RGBvalV=255; #custom RGB value for vertical features
        while i<= cubeSize:
            if i%(spacing) == 0:
                for instances in range (0,cubeSize+spacing,spacing): #draw dots = nInstances with spacin appart with i ass y offset
                    #if(spLid ==2 or spLid == 1):#the thick supporting posts
                    if(mbSize>1):
                        d.rectangle((xStart-mbSize/2+instances,yStart-mbSize/2+i, xStart+mbSize/2+instances,yStart+mbSize/2+i), fill=("white"))
                        d.point((xStart+instances,yStart+i),fill=(255,255,255))
                    else: #the normal small posts
                        d.point((xStart-mbSize*spacing/2+instances,yStart-mbSize*spacing/2+i),fill=(RGBvalV,RGBvalV,RGBvalV)) # points in edges instead
                #d.point((yStart,i),fill=(RGBval,RGBval,0))
            #------------------------------------------------------------
            i+=1*spacing
        #print(i)
        i = 0
    
    if xEnd-xStart<yEnd-yStart and (spLid==1 or spLid ==2):
      #print("trim edges")
      trimVerticalEdges(d,xStart,xEnd,yStart,yEnd,frameThickness, sLayer,spLid)
    
    elif yEnd-yStart < xEnd-xStart and (spLid==1 or spLid ==2):
      trimHorizEdges(d,xStart,xEnd,yStart,yEnd,frameThickness, sLayer,spLid)      
    
#Optional reduction of RGB intensity in the corner of each unit cell    
def cornerCorection(d,RGBval,RGBcorner,xStart, yStart, xEnd,yEnd,spLid,spacing,mbSize,sLayer):
    if spLid == 0: #not for post olny layers and not for support grids
      for y in range (yStart, yEnd,int(spacing*mbSize)):
        for x in range (xStart, xEnd,int(spacing*mbSize)):
          if sLayer>0:  
              d.point((x,y),fill=(RGBcorner,RGBcorner,RGBcorner))
              
              
#Wipes excess material from asymetrical structures (not )            
def trimVerticalEdges(d,xTrimStart,xTrimEnd,yTrimStart,yTrimEnd,frameThickness, sLayer,spLid):
  ft = int(frameThickness * 1000/50)
  if sLayer <1 and spLid !=2:
    d.line((xTrimStart-ft/2-4, yTrimStart-ft-2, xTrimStart-ft/2-4, yTrimEnd+ft+2), width =ft+6, fill=(0,0,0)) 
    d.line((xTrimEnd+ft+2, yTrimStart-ft-2, xTrimEnd+ft+2, yTrimEnd+ft+2), width =ft*2+4, fill=(0,0,0))
  
  else:
    d.line((xTrimStart-ft/2-4, yTrimStart-ft-2, xTrimStart-ft/2-4, yTrimEnd+ft+2), width =ft+2, fill=(0,0,0)) 
    d.line((xTrimEnd+ft+4, yTrimStart-ft-2, xTrimEnd+ft+4, yTrimEnd+ft+2), width =ft*2+4, fill=(0,0,0))
    
def trimHorizEdges(d,xTrimStart,xTrimEnd,yTrimStart,yTrimEnd,frameThickness, sLayer,spLid):
  ft = int(frameThickness * 1000/50)
  if sLayer <1 and spLid !=2:
    d.line((xTrimStart-ft-2, yTrimStart-ft/2-4, xTrimEnd+ft+2, yTrimStart-ft/2-4), width =ft+6, fill=(0,0,0)) 
    d.line((xTrimStart-(ft+10), yTrimEnd+ft+2, xTrimEnd+ft+10, yTrimEnd+ft+2), width =ft*2+4, fill=(0,0,0))
  
  else:
    d.line((xTrimStart-ft, yTrimStart-ft/2-4, xTrimEnd+ft+10, yTrimStart-ft/2-4), width =ft+6, fill=(0,0,0)) 
    d.line((xTrimStart-(ft+10), yTrimEnd+ft+2, xTrimEnd+ft+10, yTrimEnd+ft+2), width =ft*2+4, fill=(0,0,0))
    
    