#!/usr/bin/python3

from tkinter import *
from PIL import Image, ImageDraw, ImageFont
import pngtes as p
import drawLines as dl
import hashlib
import cProfile

   
fields = 'Cube height (mm)', 'Cube X-dimension (mm)', 'Cube Y-dimension', 'Layer Height (uM)','Beam Size (uM)','Gap between beams (uM)','Horisontal instances (1-n)','Vertical instances (1-n)','Global RGB (0-255)','Corner RGB (0-255','File name'
showimg = False

def preview(x):
    global showimg
  
    if (showimg == True):
        showimg = False
        print("Preview Off")
    else:
        showimg = True
        print("Preview On")
    
def run(entries):
    global showimg
    cbHeight = entries[0][1].get()
    cbXdim=entries[1][1].get() 
    cbYdim=entries[2][1].get()
    layHeight =entries[3][1].get()
    mbSize = entries[4][1].get()
    spacing = entries[5][1].get()
    xn = entries[6][1].get()
    yn = entries[7][1].get()
    RGBval = entries[8][1].get()
    RGBcorner = entries[9][1].get()
    file = entries[10][1].get()
    
    #Start mainLoop with parameters read from entries
    p.mainLoop(showimg,int(cbHeight),int(cbXdim),int(cbYdim),int(layHeight), int(mbSize),int(xn),int(yn),int(spacing),int(RGBval),int(RGBcorner),str(file))
    
def fetch(entries):
   print("hei entries")
   for entry in entries:
      field = entry[0]
      text  = entry[1].get()
      print('%s: "%s"' % (field, text)) 
      
      
def defaults(entries):
    global showimg
    #cProfile is used for counting the time to run methods in the program
    cProfile.run('p.mainLoop(showimg,2,12,12,25,50,3,2,150,200,200,str("default"))')
    #p.mainLoop(showimg,2,12,12,25,50,3,2,150,200,200,str("default"))
    

def makeform(root, fields):
   entries = []

   for field in fields:
      row = Frame(root)
      lab = Label(row, width=20, text=field, anchor='w')
      ent = Entry(row)
      row.pack(side=TOP, fill=X, padx=5, pady=3)
      lab.pack(side=LEFT)
      ent.pack(side=RIGHT, expand=YES, fill=X)
      entries.append((field, ent))
   return entries

    
if __name__ == '__main__':

   root = Tk()
   root.title("Qubic Lattice Generator Alpha")
   ents = makeform(root, fields)
   root.bind('<Return>', (lambda event, e=ents: fetch(e))) 
   variable = False

   b3 = Button(root, text='Show preview',
               command=(lambda t=ents: preview(t)))
   b3.pack(side=LEFT, padx=5, pady=5)
   b4 = Button(root, text='Run',
               command=(lambda t=ents: run(t)))
   b4.pack(side=LEFT, padx=5, pady=5)
   
   b5 = Button(root, text='Run defaults',
               command=(lambda t=ents: defaults(t)))
   b5.pack(side=LEFT, padx=5, pady=5)
   
   root.mainloop()